﻿using DiscUtils.Udf;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WindowsUpgradeService
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            ExtractISO();
            SetupWindows();
            InitializeComponent();
        }
        static string OutPutWork = $"{Environment.GetEnvironmentVariable("SystemDrive")}\\WindowsSetup";
        private void ExtractISO()
        {
            using (Stream isoStream = File.Open($"{Directory.GetCurrentDirectory()}\\Windows_24H2.iso", FileMode.Open))
            {
                UdfReader udfReader = new UdfReader(isoStream);
                var DIRcd = udfReader.GetDirectories("\\", "*", SearchOption.AllDirectories);
                var FILEScd = udfReader.GetFiles("\\", "*", SearchOption.AllDirectories);

                if (Directory.Exists(OutPutWork))
                {
                    Directory.Delete(OutPutWork,true);
                }

                Directory.CreateDirectory(OutPutWork);

                foreach (var dir in DIRcd) {
                    Directory.CreateDirectory($"{OutPutWork}{dir}");
                }

                foreach (var files in FILEScd) {
                    Stream destOutput = File.OpenWrite($"{OutPutWork}{files}");
                    Stream fileStream = udfReader.OpenFile(files,FileMode.Open);
                    fileStream.CopyTo(destOutput);
                }
            }
        }

        private void SetupWindows()
        {
            var ProcStartInfo = new ProcessStartInfo()
            {
                FileName = $"{OutPutWork}\\setup.exe",
                Arguments = "/auto upgrade /quiet /noreboot",
                UseShellExecute = true,
                CreateNoWindow = true,

            };
            var ProcStart = new Process()
            {
                StartInfo = ProcStartInfo,
            };
            ProcStart.Start();
            ProcStart.WaitForExit();
            if (ProcStart.ExitCode != 0) {
                MessageBox.Show("Failed");
                } else {
                MessageBox.Show("Passed");

            }

        }
    }
}
